var F = Object.defineProperty;
var k = (e, n, t) => n in e ? F(e, n, { enumerable: !0, configurable: !0, writable: !0, value: t }) : e[n] = t;
var m = (e, n, t) => (k(e, typeof n != "symbol" ? n + "" : n, t), t);
class b {
  constructor(n) {
    this.key = n;
  }
  postMessageToWindow(n, t, s) {
    const d = typeof s == "object" ? s : {}, l = {
      key: this.key,
      method: t,
      ...d
    };
    n.postMessage(
      l,
      "*"
      // TODO: Change to CoW specific origin in production. https://github.com/cowprotocol/cowswap/issues/3828
    );
  }
  listenToMessageFromWindow(n, t, s) {
    const d = (l) => {
      !x(l.data) || l.data.key !== this.key || l.data.method !== t || s(l.data);
    };
    return n.addEventListener("message", d), d;
  }
  stopListeningToMessageFromWindow(n, t, s) {
    n.removeEventListener("message", s);
  }
  stopListeningWindowListener(n, t) {
    n.removeEventListener("message", t);
  }
}
function x(e) {
  return typeof e == "object" && e !== null && "key" in e && "method" in e && typeof e.key == "string" && typeof e.method == "string";
}
var I = /* @__PURE__ */ ((e) => (e.PROVIDER_RPC_REQUEST = "PROVIDER_RPC_REQUEST", e.PROVIDER_RPC_RESPONSE = "PROVIDER_RPC_RESPONSE", e.PROVIDER_ON_EVENT = "PROVIDER_ON_EVENT", e))(I || {});
const O = new b(
  "cowSwapIframeRpcProviderTransport"
), H = ["connect", "disconnect", "close", "chainChanged", "accountsChanged"];
class G {
  /**
   * Creates an instance of IframeRpcProviderBridge.
   * @param iframeWidow - The iFrame window that will post up general RPC messages and to which the IframeRpcProviderBridge will forward the RPC result.
   *  Also it will receive some special RPC events coming from the wallet, like connect/chainChanged,accountChanged
   */
  constructor(n) {
    /**
     * The Ethereum provider instance.
     * When is null the JSON-RPC bridge is disconnected from the Ethereum provider.
     * */
    m(this, "ethereumProvider", null);
    /** Stored JSON-RPC requests, to queue them when disconnected. */
    m(this, "requestWaitingForConnection", {});
    m(this, "processRpcCallFromWindow", ({ rpcRequest: n }) => {
      if (!this.ethereumProvider) {
        n.id && (this.requestWaitingForConnection[n.id] = n);
        return;
      }
      this.processRpcRequest(n);
    });
    this.iframeWidow = n;
  }
  /**
   * Disconnects the JSON-RPC bridge from the Ethereum provider.
   */
  disconnect() {
    this.ethereumProvider = null, O.stopListeningToMessageFromWindow(
      window,
      I.PROVIDER_RPC_REQUEST,
      this.processRpcCallFromWindow
    );
  }
  /**
   * Handles the 'connect' event and sets up event listeners for Ethereum provider events.
   * @param newProvider - The Ethereum provider to connect.
   */
  onConnect(n) {
    this.ethereumProvider ? this.disconnect() : O.listenToMessageFromWindow(
      window,
      I.PROVIDER_RPC_REQUEST,
      this.processRpcCallFromWindow
    ), this.ethereumProvider = n, this.processPendingRequests(), H.forEach((t) => {
      n.on(t, (s) => this.onProviderEvent(t, s));
    });
  }
  processPendingRequests() {
    Object.keys(this.requestWaitingForConnection).forEach((n) => {
      this.processRpcRequest(this.requestWaitingForConnection[n]);
    }), this.requestWaitingForConnection = {};
  }
  /**
   * Processes a JSON-RPC request and sends appropriate response or error via the content window.
   * @param request - The JSON-RPC request to be processed.
   */
  processRpcRequest(n) {
    const { id: t, jsonrpc: s, method: d } = n;
    if (!this.ethereumProvider || !t)
      return;
    (d === "enable" ? this.ethereumProvider.enable() : this.ethereumProvider.request({ ...n, id: t })).then(
      (w) => this.forwardRpcResponseToIframe({
        rpcResponse: { jsonrpc: s, id: t, result: w }
      })
    ).catch(
      (w) => this.forwardRpcResponseToIframe({
        rpcResponse: { jsonrpc: s, id: t, error: w }
      })
    );
  }
  onProviderEvent(n, t) {
    O.postMessageToWindow(this.iframeWidow, I.PROVIDER_ON_EVENT, {
      event: n,
      params: t
    });
  }
  /**
   * Forward a JSON-RPC message to the content window.
   */
  forwardRpcResponseToIframe(n) {
    O.postMessageToWindow(
      this.iframeWidow,
      I.PROVIDER_RPC_RESPONSE,
      n
    );
  }
}
var Q = { exports: {} };
(function(e) {
  var n = Object.prototype.hasOwnProperty, t = "~";
  function s() {
  }
  Object.create && (s.prototype = /* @__PURE__ */ Object.create(null), new s().__proto__ || (t = !1));
  function d(c, r, o) {
    this.fn = c, this.context = r, this.once = o || !1;
  }
  function l(c, r, o, i, E) {
    if (typeof o != "function")
      throw new TypeError("The listener must be a function");
    var f = new d(o, i || c, E), p = t ? t + r : r;
    return c._events[p] ? c._events[p].fn ? c._events[p] = [c._events[p], f] : c._events[p].push(f) : (c._events[p] = f, c._eventsCount++), c;
  }
  function w(c, r) {
    --c._eventsCount === 0 ? c._events = new s() : delete c._events[r];
  }
  function u() {
    this._events = new s(), this._eventsCount = 0;
  }
  u.prototype.eventNames = function() {
    var r = [], o, i;
    if (this._eventsCount === 0)
      return r;
    for (i in o = this._events)
      n.call(o, i) && r.push(t ? i.slice(1) : i);
    return Object.getOwnPropertySymbols ? r.concat(Object.getOwnPropertySymbols(o)) : r;
  }, u.prototype.listeners = function(r) {
    var o = t ? t + r : r, i = this._events[o];
    if (!i)
      return [];
    if (i.fn)
      return [i.fn];
    for (var E = 0, f = i.length, p = new Array(f); E < f; E++)
      p[E] = i[E].fn;
    return p;
  }, u.prototype.listenerCount = function(r) {
    var o = t ? t + r : r, i = this._events[o];
    return i ? i.fn ? 1 : i.length : 0;
  }, u.prototype.emit = function(r, o, i, E, f, p) {
    var _ = t ? t + r : r;
    if (!this._events[_])
      return !1;
    var a = this._events[_], T = arguments.length, P, h;
    if (a.fn) {
      switch (a.once && this.removeListener(r, a.fn, void 0, !0), T) {
        case 1:
          return a.fn.call(a.context), !0;
        case 2:
          return a.fn.call(a.context, o), !0;
        case 3:
          return a.fn.call(a.context, o, i), !0;
        case 4:
          return a.fn.call(a.context, o, i, E), !0;
        case 5:
          return a.fn.call(a.context, o, i, E, f), !0;
        case 6:
          return a.fn.call(a.context, o, i, E, f, p), !0;
      }
      for (h = 1, P = new Array(T - 1); h < T; h++)
        P[h - 1] = arguments[h];
      a.fn.apply(a.context, P);
    } else {
      var U = a.length, g;
      for (h = 0; h < U; h++)
        switch (a[h].once && this.removeListener(r, a[h].fn, void 0, !0), T) {
          case 1:
            a[h].fn.call(a[h].context);
            break;
          case 2:
            a[h].fn.call(a[h].context, o);
            break;
          case 3:
            a[h].fn.call(a[h].context, o, i);
            break;
          case 4:
            a[h].fn.call(a[h].context, o, i, E);
            break;
          default:
            if (!P)
              for (g = 1, P = new Array(T - 1); g < T; g++)
                P[g - 1] = arguments[g];
            a[h].fn.apply(a[h].context, P);
        }
    }
    return !0;
  }, u.prototype.on = function(r, o, i) {
    return l(this, r, o, i, !1);
  }, u.prototype.once = function(r, o, i) {
    return l(this, r, o, i, !0);
  }, u.prototype.removeListener = function(r, o, i, E) {
    var f = t ? t + r : r;
    if (!this._events[f])
      return this;
    if (!o)
      return w(this, f), this;
    var p = this._events[f];
    if (p.fn)
      p.fn === o && (!E || p.once) && (!i || p.context === i) && w(this, f);
    else {
      for (var _ = 0, a = [], T = p.length; _ < T; _++)
        (p[_].fn !== o || E && !p[_].once || i && p[_].context !== i) && a.push(p[_]);
      a.length ? this._events[f] = a.length === 1 ? a[0] : a : w(this, f);
    }
    return this;
  }, u.prototype.removeAllListeners = function(r) {
    var o;
    return r ? (o = t ? t + r : r, this._events[o] && w(this, o)) : (this._events = new s(), this._eventsCount = 0), this;
  }, u.prototype.off = u.prototype.removeListener, u.prototype.addListener = u.prototype.on, u.prefixed = t, u.EventEmitter = u, e.exports = u;
})(Q);
class j {
  constructor() {
    m(this, "subscriptions", {});
  }
  on(n) {
    const { event: t, handler: s } = n;
    return this.subscriptions[t] || (this.subscriptions[t] = []), this.subscriptions[t].push(s), n;
  }
  off(n) {
    const { event: t, handler: s } = n;
    return this.subscriptions[t] && (this.subscriptions[t] = this.subscriptions[t].filter((d) => d !== s)), n;
  }
  emit(n, t) {
    this.subscriptions[n] && this.subscriptions[n].forEach((s) => s(t));
  }
}
var R = /* @__PURE__ */ ((e) => (e.ACTIVATE = "ACTIVATE", e.UPDATE_HEIGHT = "UPDATE_HEIGHT", e.SET_FULL_HEIGHT = "SET_FULL_HEIGHT", e.EMIT_COW_EVENT = "EMIT_COW_EVENT", e.PROVIDER_RPC_REQUEST = "PROVIDER_RPC_REQUEST", e.INTERCEPT_WINDOW_OPEN = "INTERCEPT_WINDOW_OPEN", e))(R || {}), y = /* @__PURE__ */ ((e) => (e.UPDATE_PARAMS = "UPDATE_PARAMS", e.UPDATE_APP_DATA = "UPDATE_APP_DATA", e.PROVIDER_RPC_RESPONSE = "PROVIDER_RPC_RESPONSE", e.PROVIDER_ON_EVENT = "PROVIDER_ON_EVENT", e))(y || {}), C = /* @__PURE__ */ ((e) => (e.SWAP = "swap", e.LIMIT = "limit", e.ADVANCED = "advanced", e.YIELD = "yield", e))(C || {});
const ue = [
  "primary",
  "background",
  "paper",
  "text",
  "danger",
  "warning",
  "alert",
  "info",
  "success"
], v = new b("cowSwapWidget");
class $ {
  constructor(n, t = []) {
    m(this, "eventEmitter", new j());
    m(this, "listeners", []);
    m(this, "widgetListener");
    this.contentWindow = n, this.updateListeners(t), this.widgetListener = v.listenToMessageFromWindow(
      this.contentWindow,
      R.EMIT_COW_EVENT,
      (s) => this.eventEmitter.emit(s.event, s.payload)
    );
  }
  stopListeningIframe() {
    v.stopListeningWindowListener(this.contentWindow, this.widgetListener);
  }
  updateListeners(n) {
    for (const t of this.listeners)
      this.eventEmitter.off(t);
    this.listeners = n || [];
    for (const t of this.listeners)
      this.eventEmitter.on(t);
  }
}
class B {
  constructor(n, t) {
    m(this, "forwardSdkMessage");
    this.appWindow = n, this.iframeWidow = t, this.forwardSdkMessage = (s) => {
      q(s.data) && s.origin !== window.location.origin && (Y(s.data) ? this.appWindow.parent.postMessage(s.data, "*") : z(s.data) && this.iframeWidow.postMessage(s.data, "*"));
    }, this.startListening();
  }
  startListening() {
    this.appWindow.addEventListener("message", this.forwardSdkMessage);
  }
  stopListening() {
    this.appWindow.removeEventListener("message", this.forwardSdkMessage);
  }
}
function q(e) {
  return typeof e == "object" && e !== null && "id" in e && typeof e.id == "string";
}
function Y(e) {
  return "method" in e && typeof e.method == "string" && "params" in e && "env" in e && typeof e.env == "object" && e.env !== null && "sdkVersion" in e.env;
}
function z(e) {
  return "success" in e && typeof e.success == "boolean" && "version" in e && typeof e.version == "string";
}
function J(e) {
  return !!(e && typeof e == "object");
}
const A = "_";
function K(e) {
  const n = typeof e.baseUrl == "string" ? e.baseUrl : "https://swap.cow.fi", t = N(e);
  return n + "/#" + t + "?" + V(e);
}
function N(e) {
  const { chainId: n = 1, sell: t, buy: s, tradeType: d = C.SWAP } = e, l = [(t == null ? void 0 : t.asset) || A, (s == null ? void 0 : s.asset) || A].map(encodeURIComponent).join("/");
  return `/${n}/widget/${d}/${l}`;
}
function V(e) {
  const n = new URLSearchParams();
  return Z(X(n, e), e);
}
function X(e, n) {
  const { sell: t, buy: s } = n;
  return t != null && t.amount && e.append("sellAmount", t.amount), s != null && s.amount && e.append("buyAmount", s.amount), e;
}
function Z(e, n) {
  const t = n.theme;
  return t ? (J(t) ? (e.append("palette", encodeURIComponent(JSON.stringify(t))), e.append("theme", t.baseTheme)) : (e.append("palette", "null"), e.append("theme", t)), e) : (e.append("palette", "null"), e);
}
const M = "640px", ee = "450px", te = 20;
function fe(e, n) {
  const { params: t, provider: s, listeners: d } = n;
  let l = s, w = t;
  const u = ne(t);
  e.innerHTML = "", e.appendChild(u);
  const { contentWindow: c } = u;
  if (!c)
    throw console.error("Iframe does not contain a window", u), new Error("Iframe does not contain a window!");
  const r = [];
  r.push(se(c, t.appCode)), r.push(...oe(u, t.height, t.maxHeight)), r.push(re());
  const o = new $(window, d);
  let i = W(c, null, l);
  u.addEventListener("load", () => L(c, w, l));
  const E = new B(window, c);
  return {
    updateParams: (f) => {
      w = f, L(c, w, l);
    },
    updateListeners: (f) => o.updateListeners(f),
    updateProvider: (f) => {
      l = f, i = W(c, i, f);
    },
    destroy: () => {
      i.disconnect(), o.stopListeningIframe(), r.forEach((f) => window.removeEventListener("message", f)), E.stopListening(), e.removeChild(u);
    }
  };
}
function W(e, n, t) {
  n && n.disconnect();
  const s = n || new G(e);
  return t && s.onConnect(t), s;
}
function ne(e) {
  const { width: n = ee, height: t = M } = e, s = document.createElement("iframe");
  return s.src = K(e), s.width = n, s.height = t, s.style.border = "0", s.allow = "clipboard-read; clipboard-write", s;
}
function L(e, n, t) {
  const s = !!t, d = N(n), l = V(n).toString(), { theme: w, ...u } = n;
  v.postMessageToWindow(e, y.UPDATE_PARAMS, {
    urlParams: {
      pathname: d,
      search: l
    },
    appParams: u,
    hasProvider: s
  });
}
function se(e, n) {
  return v.listenToMessageFromWindow(window, R.ACTIVATE, () => {
    v.postMessageToWindow(e, y.UPDATE_APP_DATA, {
      metaData: n ? { appCode: n } : void 0
    });
  });
}
function re() {
  return v.listenToMessageFromWindow(
    window,
    R.INTERCEPT_WINDOW_OPEN,
    ({ href: e, rel: n, target: t }) => {
      const s = e.toString();
      if (!s.startsWith("http") && s.match(/^[a-zA-Z0-9]+:\/\//)) {
        window.open(s, t, n);
        return;
      }
    }
  );
}
function oe(e, n = M, t) {
  return [
    v.listenToMessageFromWindow(window, R.UPDATE_HEIGHT, (s) => {
      const d = s.height ? s.height + te : void 0;
      e.style.height = d ? `${t ? Math.min(d, t) : d}px` : n;
    }),
    v.listenToMessageFromWindow(window, R.SET_FULL_HEIGHT, ({ isUpToSmall: s }) => {
      e.style.height = s ? n : `${t || document.body.offsetHeight}px`;
    })
  ];
}
const ie = Object.values(C);
function pe(e, n, t) {
  if (S(e)) {
    const s = e[t];
    return D(s) ? s[n] : s;
  }
  if (D(e)) {
    const s = e[n];
    return S(s) ? s[t] : s;
  }
  return e;
}
function S(e) {
  return typeof e != "object" ? !1 : Object.keys(e).every((n) => ie.includes(n));
}
const ae = /^\d+$/;
function D(e) {
  return typeof e != "object" ? !1 : Object.keys(e).every((n) => typeof n == "number" || ae.test(n));
}
export {
  C as TradeType,
  ue as WIDGET_PALETTE_COLORS,
  R as WidgetMethodsEmit,
  y as WidgetMethodsListen,
  fe as createCowSwapWidget,
  J as isCowSwapWidgetPalette,
  D as isPerNetworkConfig,
  S as isPerTradeTypeConfig,
  pe as resolveFlexibleConfig,
  v as widgetIframeTransport
};
